Index: branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 367)
+++ branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 440)
@@ -7494,144 +8146,115 @@
 
         uint64_t flit = 0;
-        uint64_t dest =
-          m_xram_rsp_to_cc_send_srcid_fifo.read() << 
-          (DspinDhccpParam::SRCID_WIDTH - vci_param::S);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            dest,
-            DspinDhccpParam::MULTI_INVAL_DEST);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            m_cc_global_id,
-            DspinDhccpParam::MULTI_INVAL_SRCID);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_xram_rsp_to_cc_send_trdid.read(),
-            DspinDhccpParam::MULTI_INVAL_UPDT_INDEX);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            multi_inval_type,
-            DspinDhccpParam::FROM_MC_TYPE);
-
-        p_dspin_out.write = true;
-        p_dspin_out.data  = flit; 
-
-        break;
-      }
-
-    case CC_SEND_XRAM_RSP_INVAL_NLINE:
-      {
-        uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_EOP);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_xram_rsp_to_cc_send_nline.read(),
-            DspinDhccpParam::MULTI_INVAL_NLINE);
-        
-
+        uint64_t dest = m_xram_rsp_to_cc_send_srcid_fifo.read() <<
+                        (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    dest,
+                                    DspinDhccpParam::MULTI_INVAL_DEST);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    m_cc_global_id,
+                                    DspinDhccpParam::MULTI_INVAL_SRCID);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    r_xram_rsp_to_cc_send_trdid.read(),
+                                    DspinDhccpParam::MULTI_INVAL_UPDT_INDEX);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    multi_inval_type,
+                                    DspinDhccpParam::FROM_MC_TYPE);
         p_dspin_out.write = true;
         p_dspin_out.data  = flit;
-
         break;
-      }
-
+    }
+
+    //////////////////////////////////
+    case CC_SEND_XRAM_RSP_INVAL_NLINE:
+    {
+        uint64_t flit = 0;
+
+        DspinDhccpParam::dspin_set( flit,
+                                    r_xram_rsp_to_cc_send_nline.read(),
+                                    DspinDhccpParam::MULTI_INVAL_NLINE);
+        p_dspin_out.eop   = true;
+        p_dspin_out.write = true;
+        p_dspin_out.data  = flit;
+        break;
+    }
+
+    /////////////////////////////////////
+    case CC_SEND_CONFIG_BRDCAST_HEADER:
     case CC_SEND_XRAM_RSP_BRDCAST_HEADER:
     case CC_SEND_WRITE_BRDCAST_HEADER:
     case CC_SEND_CAS_BRDCAST_HEADER:
-      {
+    {
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set(
-            flit,
-            m_broadcast_address,
-            DspinDhccpParam::BROADCAST_BOX);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            m_cc_global_id,
-            DspinDhccpParam::BROADCAST_SRCID);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_BC);
-
+        DspinDhccpParam::dspin_set( flit,
+                                    m_broadcast_boundaries,
+                                    DspinDhccpParam::BROADCAST_BOX);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    m_cc_global_id,
+                                    DspinDhccpParam::BROADCAST_SRCID);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    1ULL,
+                                    DspinDhccpParam::FROM_MC_BC);
         p_dspin_out.write = true;
         p_dspin_out.data  = flit;
-
         break;
-      }
-
+    }
+    ////////////////////////////////////
     case CC_SEND_XRAM_RSP_BRDCAST_NLINE:
-      {
+    {
         uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_EOP);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_xram_rsp_to_cc_send_nline.read(),
-            DspinDhccpParam::BROADCAST_NLINE);
-
+        DspinDhccpParam::dspin_set( flit,
+                                    r_xram_rsp_to_cc_send_nline.read(),
+                                    DspinDhccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
+        p_dspin_out.eop   = true;
         p_dspin_out.data  = flit;
-
         break;
-      }
-
+    }
+    //////////////////////////////////
+    case CC_SEND_CONFIG_BRDCAST_NLINE:
+    {
+        uint64_t flit = 0;
+        DspinDhccpParam::dspin_set( flit,
+                                    r_config_to_cc_send_nline.read(),
+                                    DspinDhccpParam::BROADCAST_NLINE);
+        p_dspin_out.write = true;
+        p_dspin_out.eop   = true;
+        p_dspin_out.data  = flit;
+        break;
+    }
+    /////////////////////////////////
     case CC_SEND_WRITE_BRDCAST_NLINE:
-      {
+    {
         uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_EOP);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_write_to_cc_send_nline.read(),
-            DspinDhccpParam::BROADCAST_NLINE);
-
+        DspinDhccpParam::dspin_set( flit,
+                                    r_write_to_cc_send_nline.read(),
+                                    DspinDhccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
+        p_dspin_out.eop   = true;
         p_dspin_out.data  = flit;
-
         break;
-      }
-
+    }
+    ///////////////////////////////
     case CC_SEND_CAS_BRDCAST_NLINE:
-      {
+    {
         uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_EOP);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_cas_to_cc_send_nline.read(),
-            DspinDhccpParam::BROADCAST_NLINE);
-
+        DspinDhccpParam::dspin_set( flit,
+                                    r_cas_to_cc_send_nline.read(),
+                                    DspinDhccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
+        p_dspin_out.eop   = true;
         p_dspin_out.data  = flit;
-
         break;
-      }
-
+    }
+    ///////////////////////////////
     case CC_SEND_WRITE_UPDT_HEADER:
-      {
+    {
         if(not m_write_to_cc_send_inst_fifo.rok()) break;
 
@@ -7641,5 +8264,5 @@
           multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_INST;
         }
-        else 
+        else
         {
           multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_DATA;
@@ -7648,6 +8271,6 @@
         uint64_t flit = 0;
         uint64_t dest =
-          m_write_to_cc_send_srcid_fifo.read() << 
-          (DspinDhccpParam::SRCID_WIDTH - vci_param::S);
+          m_write_to_cc_send_srcid_fifo.read() <<
+          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
 
         DspinDhccpParam::dspin_set(
@@ -7675,8 +8298,8 @@
 
         break;
-      }
-
+    }
+    //////////////////////////////
     case CC_SEND_WRITE_UPDT_NLINE:
-      {
+    {
         uint64_t flit = 0;
 
@@ -7695,20 +8318,10 @@
 
         break;
-      }
-
+    }
+    /////////////////////////////
     case CC_SEND_WRITE_UPDT_DATA:
-      {
-        uint8_t multi_updt_eop;
-        if(  r_cc_send_cpt.read() ==
-            (r_write_to_cc_send_count.read()-1))
-        {
-          multi_updt_eop = 1;
-        }
-        else
-        {
-          multi_updt_eop = 0;
-        }
-
-        uint8_t multi_updt_cpt  = 
+    {
+
+        uint8_t multi_updt_cpt  =
           r_cc_send_cpt.read() + r_write_to_cc_send_index.read();
 
@@ -7717,9 +8330,4 @@
 
         uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            (uint64_t)multi_updt_eop,
-            DspinDhccpParam::FROM_MC_EOP);
 
         DspinDhccpParam::dspin_set(
@@ -7734,11 +8342,12 @@
 
         p_dspin_out.write = true;
+        p_dspin_out.eop   = (r_cc_send_cpt.read() == (r_write_to_cc_send_count.read()-1));
         p_dspin_out.data  = flit;
 
         break;
-      }
-
+    }
+    ////////////////////////////
     case CC_SEND_CAS_UPDT_HEADER:
-      {
+    {
         if (not m_cas_to_cc_send_inst_fifo.rok()) break;
 
@@ -7748,5 +8357,5 @@
           multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_INST;
         }
-        else 
+        else
         {
           multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_DATA;
@@ -7755,6 +8364,6 @@
         uint64_t flit = 0;
         uint64_t dest =
-          m_cas_to_cc_send_srcid_fifo.read() << 
-          (DspinDhccpParam::SRCID_WIDTH - vci_param::S);
+          m_cas_to_cc_send_srcid_fifo.read() <<
+          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
 
         DspinDhccpParam::dspin_set(
@@ -7782,8 +8391,8 @@
 
         break;
-      }
-
+    }
+    ////////////////////////////
     case CC_SEND_CAS_UPDT_NLINE:
-      {
+    {
         uint64_t flit = 0;
 
@@ -7802,24 +8411,9 @@
 
         break;
-      }
-
+    }
+    ///////////////////////////
     case CC_SEND_CAS_UPDT_DATA:
-      {
-        uint8_t multi_updt_eop;
-        if(not r_cas_to_cc_send_is_long.read())
-        {
-          multi_updt_eop = 1;
-        }
-        else
-        {
-          multi_updt_eop = 0;
-        }
-
+    {
         uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            (uint64_t)multi_updt_eop,
-            DspinDhccpParam::FROM_MC_EOP);
 
         DspinDhccpParam::dspin_set(
@@ -7834,17 +8428,13 @@
 
         p_dspin_out.write = true;
+        p_dspin_out.eop   = not r_cas_to_cc_send_is_long.read();
         p_dspin_out.data  = flit;
 
         break;
-      }
-
+    }
+    ////////////////////////////////
     case CC_SEND_CAS_UPDT_DATA_HIGH:
-      {
+    {
         uint64_t flit = 0;
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_EOP);
 
         DspinDhccpParam::dspin_set(
@@ -7859,12 +8449,13 @@
 
         p_dspin_out.write = true;
+        p_dspin_out.eop   = true;
         p_dspin_out.data  = flit;
 
         break;
-      }
+    }
   }
 
   ///////////////////////////////////////////////////////////////////
-  // Target command signals from the p_dspin_in port (CC_RECEIVE FSM)
+  //  p_dspin_in port (CC_RECEIVE FSM)
   ///////////////////////////////////////////////////////////////////
   p_dspin_in.read = false;
@@ -7876,4 +8467,5 @@
       }
     case CC_RECEIVE_CLEANUP:
+    case CC_RECEIVE_CLEANUP_EOP:
       {
         p_dspin_in.read = m_cc_receive_to_cleanup_fifo.wok();
